SIGRETURN(2)

NAME
sigreturn - return from signal

SYNOPSIS
#include <signal.h>

    struct	sigcontext {
    	int	sc_onstack;		/* sigstack state to restore */
    	int	sc_mask;		/* signal mask to restore */
    	int	sc_esp;			/* machine state */
    	int	sc_ebp;
    	int	sc_isp;
    	int	sc_eip;
    	int	sc_efl;
    	int	sc_es;
    	int	sc_ds;
    	int	sc_cs;
    	int	sc_ss;
    	int	sc_edi;
    	int	sc_esi;
    	int	sc_ebx;
    	int	sc_edx;
    	int	sc_ecx;
    	int	sc_eax;
    #  define sc_sp sc_esp
    #  define sc_fp sc_ebp
    #  define sc_pc sc_eip
    #  define sc_ps sc_efl
    };

int
sigreturn(struct sigcontext *scp);

DESCRIPTION
Sigreturn() allows users to atomically unmask, switch stacks, and return from a signal context. The processes signal mask and stack status are restored from the context. The system call does not return; the users stack pointer, frame pointer, argument pointer, and processor status longword are restored from the context. Execution resumes at the specified pc. This system call is used by the trampoline code and longjmp(3) when returning from a signal to the previously executing program.

NOTES
This system call is not available in 4.2 BSD hence it should not be used if backward compatibility is needed.

RETURN VALUES
If successful, the system call does not return. Otherwise, a value of -1 is returned and errno is set to indicate the error.

ERRORS
Sigreturn() will fail and the process context will remain unchanged if one of the following occurs.

[EFAULT]
    Scp points to memory that is not a valid part of the process address space.

[EINVAL]
    The process status longword is invalid or would improperly raise the privilege level of the process.

SEE ALSO
sigvec(2), setjmp(3)

HISTORY
The sigreturn() function call appeared in 4.3BSD.